package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.apotheosis.mixin.LivingEntityInvoker;
import dev.shadowsoffire.placebo.util.StepFunction;
import java.util.Map;
import java.util.function.Function;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;

public class ExecutingAffix extends Affix {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.ExecutingAffix> CODEC;
  
  protected final Map<LootRarity, StepFunction> values;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)GemBonus.VALUES_CODEC.fieldOf("values").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.effect.ExecutingAffix::new));
  }
  
  public ExecutingAffix(Map<LootRarity, StepFunction> values) {
    super(AffixType.ABILITY);
    this.values = values;
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return (cat == LootCategory.HEAVY_WEAPON && this.values.containsKey(rarity));
  }
  
  public MutableComponent getDescription(ItemStack stack, LootRarity rarity, float level) {
    return Component.m_237110_("affix." + getId() + ".desc", new Object[] { fmt(100.0F * getTrueLevel(rarity, level)) });
  }
  
  public Component getAugmentingText(ItemStack stack, LootRarity rarity, float level) {
    MutableComponent comp = getDescription(stack, rarity, level);
    MutableComponent mutableComponent1 = Component.m_237110_("%s%%", new Object[] { fmt(100.0F * getTrueLevel(rarity, 0.0F)) });
    MutableComponent mutableComponent2 = Component.m_237110_("%s%%", new Object[] { fmt(100.0F * getTrueLevel(rarity, 1.0F)) });
    return (Component)comp.m_7220_((Component)valueBounds((Component)mutableComponent1, (Component)mutableComponent2));
  }
  
  private float getTrueLevel(LootRarity rarity, float level) {
    return ((StepFunction)this.values.get(rarity)).get(level);
  }
  
  public void doPostAttack(ItemStack stack, LootRarity rarity, float level, LivingEntity user, Entity target) {
    float threshold = getTrueLevel(rarity, level);
    if (Apotheosis.getLocalAtkStrength((Entity)user) >= 0.98D && target instanceof LivingEntity) {
      LivingEntity living = (LivingEntity)target;
      if (!(living.m_9236_()).f_46443_ && 
        living.m_21223_() / living.m_21233_() < threshold) {
        DamageSource src = living.m_269291_().m_269298_(Apoth.DamageTypes.EXECUTE, (Entity)user);
        if (!((LivingEntityInvoker)living).callCheckTotemDeathProtection(src)) {
          SoundEvent soundevent = ((LivingEntityInvoker)living).callGetDeathSound();
          if (soundevent != null)
            living.m_5496_(soundevent, ((LivingEntityInvoker)living).callGetSoundVolume(), living.m_6100_()); 
          living.m_6703_(user);
          if (user instanceof Player) {
            Player p = (Player)user;
            living.m_6598_(p);
          } 
          living.m_21231_().m_289194_(src, 99999.0F);
          living.m_21153_(0.0F);
          living.m_6667_(src);
        } 
      } 
    } 
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
}
